/*************************************************************************
IFDAYIS.C  (version 1.02)

Welcome to IFDAYIS.C source code.  This program is designed to be placed
in the autoexec.bat of a computer and at boot time decide wheather to run
a specified program or not, in accordance with parameters on the command
line.  Some `C' programmers might be horrified by this source code, because
I violate the `Pretty Law'.  Well, in my defense, I had a college instructor,
a man with a PHD in CS, who was a terrorist on `Style & Grace'.  This is the
man that wanted main() to contain only function calls.  He gave me a `B' in
the course because I had three lines of logic in main(), ONCE during the
course. It is for old, insane, Dr. Whats-his-name that I write this program
in straight-in-line code, and just for spite, I'm going to use `goto s'
{ The highest sin }.  I did start off writing a `pretty' program, in fact
I even made one function, but then I thought better of it.  And besides, the
fact of the matter is: good old sloppy straight-in-line code runs the
fastest.

Enjoy, Thomas Nofsinger, 4503 Chapman St., The Colony, TX 75056

**************************************************************************/



#include <time.h>
#include <stdio.h>
#include <ctype.h>
#include <process.h>
#include <errno.h>

time_t ltime;

char dbuffer[27], datafile[49], c[2];
char cpu_day[4],cpu_date[3],cpu_mon[4],cpu_hour[3],cpu_min[3],cpu_year[5];
char file_day[4],file_date[3],file_mon[4],file_hour[3],file_min[3],file_year[5];
char cl_day[4],cl_num[2],cl_not_dash[2],cl_not_time[12],cl_stop_hour[3],cl_stop_min[3];
char cl_start_hour[3],cl_start_min[3],cl_not_switch[3],cl_none[12],cl_program[49];
FILE *fp_in, *fp_out, *fopen();
int i, n, x, y, z;
void test_num();


main (argc, argv)
int argc;
char *argv[];
{  /* start of main */

   printf("\n           *******************************************************");
   printf("\n           *                                                     *");
   printf("\n           *          Copyright 1991  Thomas I Nofsinger         *");
   printf("\n           *                 All Rights Reserved                 *");
   printf("\n           *                    version 1.02                     *");
   printf("\n           *******************************************************\n\n");


	if (argc < 4)
	{
		printf("\nInsufficient number of parameters. \n\n");
		printf("   IFDAYIS Usage:\n");
		printf("   IFDAYIS day number /n_time-time program_path_&_name \n\n");
		printf("   Where day is a day of the week, or the word any, or all.\n");
		printf("      (eg., Mon Tue Wed Thu Fri Sat Sun Any All).\n");
		printf("   Where number is `1' if you only want the program to execute on the\n");
		printf("      first bootup of the day, or `0' to disregard the number of boots.\n");
		printf("   Where /n_time-time is a`/n' immediately followed by time range,\n");
		printf("      in military time, that the program should NOT execute (eg., /n0900-1400).\n");
		printf("      Enter '/none' if there are no hour limitations.\n");
		printf("   Where program_path_&_name is the full path and name of the file you\n");
		printf("      want executed (eg., c:\\util\\virus\\virscan).\n\n");
		printf("Examples: IFDAYIS MON 1 /none c:\\dos\\chkdsk c: \n");
		printf("   or     IFDAYIS ALL 1 /n0900-1400 c:\\util\\virus\\virscan c:\n\n");
		printf("\n\nIf you want to place IFDAYIS twice in your autoexec.bat, you need to\n");
		printf("copy IFDAYIS.EXE to IFDAY#2.EXE, or anything else you like, and then\n");
		printf("you may use the second copy of IFDAYIS like the first. This is done because \n");
		printf("both copies of IFDAYIS create their own datafile to keep track of the last\n");
		printf("time they ran.");
		exit(1);
	}

	time(&ltime);                             /*  get time, in lower case, */
	strcpy(dbuffer, strlwr(ctime(&ltime)));   /*  and place it in buffer   */

	strncpy(cpu_day, dbuffer, 3);
	strncpy(cpu_date, dbuffer + 8, 2);
	strncpy(cpu_mon, dbuffer + 4, 3);
	strncpy(cpu_hour, dbuffer + 11, 2);
	strncpy(cpu_min, dbuffer + 14, 2);
	strncpy(cpu_year, dbuffer + 20, 4);

	strncpy(cl_day, strlwr(argv[1]), 3);
	strncpy(cl_num, strlwr(argv[2]), 1);
	strncpy(cl_not_time, strlwr(argv[3]), 11);
	strcpy(cl_none, cl_not_time);
	strncpy(cl_not_dash, cl_not_time + 6, 1);
	strncpy(cl_not_switch, cl_not_time, 2);
	strncpy(cl_stop_hour, cl_not_time + 2, 2);
	strncpy(cl_stop_min, cl_not_time + 4, 2);
	strncpy(cl_start_hour, cl_not_time + 7, 2);
	strncpy(cl_start_min, cl_not_time + 9, 2);

	strcpy(cl_program, argv[4]);        /* make str of full command line for */
	if ( argc > 4 )                     /* program execution, including para. */
		{
			for(i=5; i <= argc; ++i)
			{
				strcat(cl_program, " ");
				strcat(cl_program, argv[i]);
			}
		strcpy(cl_program, strlwr(cl_program));

		}

	strcpy(datafile, argv[0]);    /* creates datafile name to match program */
	x = strlen(datafile);
	datafile[x-3] = 'D';
	datafile[x-2] = 'A';
	datafile[x-1] = 'T';
	datafile[x] = '\0';




	printf("%s",dbuffer);
/*    printf("%s,%s,%s,%s,%s\n",cpu_day, cpu_date, cpu_hour, cpu_min, cpu_year); */
	printf("%s,%s,%s,%s\n",cl_day,cl_num,cl_not_time,cl_program);
/*    printf("%s,%s,%s,%s,%s\n",cl_not_switch,cl_stop_hour,cl_stop_min,cl_start_hour,cl_start_min);
	printf("%s,%s,%s,%s\n", cl_none,cl_program,argv[0],datafile);
 work checker's
*/
	/************************************************************************
		Our setup is done.  We have the computers day, hour, min., and year.
		And we have the agrv's to main parsed in their slots.  What remains
		is for the program to check the validity of the computers clock,
		i.e., is the year the default year on a XT without a clock; the
		validity of the argv's to main (proper syntax); load the date file
		and then deteremine if it's time to run the stated program.
	*************************************************************************/

	x = atoi(cpu_year);
	if( x < 1991 )
		{
			printf("\n\n    Your computer's clock has an incorrect year.");
			printf("\n\n    Please check the Date and Time of the Computer's clock.");
			printf("\n\n    Program IFDAYIS halted. \n\n");
			exit(1);

		}


	if((fp_in = fopen(datafile, "r"))==0)
		{
			fclose(fp_in);
			printf("\n\n          DATA FILE NOT FOUND.  ASSUMING THAT THIS IS");
			printf("\n        THE FIRST TIME IFDAYIS HAS BEEN RAN ON THIS SYSTEM.\n\n");

			fp_out = fopen(datafile, "w");
			fprintf(fp_out,"day\n");
			fprintf(fp_out,"00\n");
			fprintf(fp_out,"mot\n");
			fprintf(fp_out,"00\n");
			fprintf(fp_out,"00\n");
			fprintf(fp_out,"1991\n");
			fclose(fp_out);
			fp_in = fopen(datafile, "r");


		}

	fscanf(fp_in,"%s",file_day);
	fscanf(fp_in,"%s",file_date);
	fscanf(fp_in,"%s",file_mon);
	fscanf(fp_in,"%s",file_hour);
	fscanf(fp_in,"%s",file_min);
	fscanf(fp_in,"%s",file_year);
	fclose(fp_in);

	fp_out = fopen(datafile, "w");
	fprintf(fp_out,"%s\n",cpu_day);
	fprintf(fp_out,"%s\n",cpu_date);
	fprintf(fp_out,"%s\n",cpu_mon);
	fprintf(fp_out,"%s\n",cpu_hour);
	fprintf(fp_out,"%s\n",cpu_min);
	fprintf(fp_out,"%s\n",cpu_year);
	fclose(fp_out);


	/* test cl_day as valid, and for if it matches today */

	if( 0 == strcmp( cl_day, "all\0"))
		goto cl_num_test;
	else if( 0 == strcmp( cl_day, "any\0"))
		goto cl_num_test;
	else if( 0 == strcmp( cl_day, "mon\0"))
		{
			if( 0 != strcmp(cl_day, cpu_day))
				{
					printf("\nNot Monday, continue normal boot\n\n");
					exit(1);
				}
			goto cl_num_test;
		}
	else if( 0 == strcmp( cl_day, "tue\0"))
		{
			if( 0 != strcmp(cl_day, cpu_day))
				{
					printf("\nNot Tuesday, continue normal boot\n\n");
					exit(1);
				}
			goto cl_num_test;
		}
	else if( 0 == strcmp( cl_day, "wed\0"))
		{
			if( 0 != strcmp(cl_day, cpu_day))
				{
					printf("\nNot Wednesday, continue normal boot\n\n");
					exit(1);
				}
			goto cl_num_test;
		}

	else if( 0 == strcmp( cl_day, "thu\0"))
		{
			if( 0 != strcmp(cl_day, cpu_day))
				{
					printf("\nNot Thursday, continue normal boot\n\n");
					exit(1);
				}
			goto cl_num_test;
		}

	else if( 0 == strcmp( cl_day, "fri\0"))
		{
			if( 0 != strcmp(cl_day, cpu_day))
				{
					printf("\nNot Friday, continue normal boot\n\n");
					exit(1);
				}
			goto cl_num_test;
		}

	else if( 0 == strcmp( cl_day, "sat\0"))
		{
			if( 0 != strcmp(cl_day, cpu_day))
				{
					printf("\nNot Saturday, continue normal boot\n\n");
					exit(1);
				}
			goto cl_num_test;
		}

	else if( 0 == strcmp( cl_day, "sun\0"))
		{
			if( 0 != strcmp(cl_day, cpu_day))
				{
					printf("\nNot Sunday, continue normal boot\n\n");
					exit(1);
				}
			goto cl_num_test;
		}

	else
		printf("\n\n Invalid day parameter.  Valid parameters are:");
		printf("\n ALL, ANY, MON, TUE, WED, THU, FRI, SAT, SUN \n\n");
		exit(1);

cl_num_test:        /*  test cl_num and has is already ran once today? */

	i = 0;
	if( 0 == strcmp( cl_num, "v\0"))
		{
			printf("\n\n    This is version 1.02 of IFDAYIS\n");
			printf("\n    Dated 18 June 1991\n");
			exit(1);
		}
	if( 0 == strcmp( cl_num, "0\0"))
		goto cl_not_test;
	if( 0 == strcmp( cl_num, "1\0"))
		{
			if( 0 == strcmp(file_date, cpu_date))
			   ++i;
			if( 0 == strcmp(file_day, cpu_day))
			   ++i;
			if( 0 == strcmp(file_mon, cpu_mon))
			   ++i;
			if( 0 == strcmp(file_year, cpu_year))
			   ++i;
		}

	if( i == 4 )
		{
			printf("\n\n System booted earlier today.  Boot continuing\n\n");
			exit(1);
		}

	if( 0 != strcmp( cl_num, "1\0"))
		{
			printf("\n\n Invalid num parameter.  Valid parameters are:");
			printf("\n 0 or 1 \n\n");
			exit(1);
		}



cl_not_test:

	if( 0 != strcmp( cl_not_switch, "/n\0"))
		{
			printf("\n\n Invalid NOT-TIME Switch.  A valid not-time switch must");
			printf("\n start with a `/n', followed by two, four digit times");
			printf("\n in military time, seperated by a dash, eg., `/n0900-1400'\n\n");
			exit(1);
		}

	if ( 0 == strcmp( cl_none, "/none\0"))
		goto doit;   /* to get here the day had to match, or be any, or all */


	if( 11 != strlen(strlwr(argv[3])))
		{
			printf("\n\n Invalid NOT-TIME Switch.  A valid not-time switch must");
			printf("\n start with a `/n', followed by two, four digit times");
			printf("\n in military time, seperated by a dash, eg., `/n0900-1400'\n\n");
			exit(1);
		}

	if( 0 != strcmp(cl_not_dash, "-\0"))
		{
			printf("\n\n Invalid NOT-TIME Switch.  A valid not-time switch must");
			printf("\n start with a `/n', followed by two, four digit times");
			printf("\n in military time, seperated by a dash, eg., `/n0900-1400'\n\n");
			exit(1);
		}

	strncpy( c, cl_not_time + 2, 1);
	test_num( c );
	strncpy( c, cl_not_time + 3, 1);
	test_num( c );
	strncpy( c, cl_not_time + 4, 1);
	test_num( c );
	strncpy( c, cl_not_time + 5, 1);
	test_num( c );
	strncpy( c, cl_not_time + 7, 1);
	test_num( c );
	strncpy( c, cl_not_time + 8, 1);
	test_num( c );
	strncpy( c, cl_not_time + 9, 1);
	test_num( c );
	strncpy( c, cl_not_time + 10, 1);
	test_num( c );





	if (( 0 > atoi(cl_stop_hour)) || (23 < atoi(cl_stop_hour)) )
		{
			printf("\n\n Invalid TIME parameter.  A valid parameter must");
			printf("\n start with a `/n', followed by two, four digit times");
			printf("\n in military time, seperated by a dash, eg., `/n0900-1400'\n\n");
			exit(1);
		}

	if (( 0 > atoi(cl_stop_min)) || (59 < atoi(cl_stop_min)) )
		{
			printf("\n\n Invalid TIME parameter.  A valid parameter must");
			printf("\n start with a `/n', followed by two, four digit times");
			printf("\n in military time, seperated by a dash, eg., `/n0900-1400'\n\n");
			exit(1);
		}

	if (( 0 > atoi(cl_start_hour)) || (23 < atoi(cl_start_hour)) )
		{
			printf("\n\n Invalid TIME parameter.  A valid parameter must");
			printf("\n start with a `/n', followed by two, four digit times");
			printf("\n in military time, seperated by a dash, eg., `/n0900-1400'\n\n");
			exit(1);
		}

	if (( 0 > atoi(cl_start_min)) || (59 < atoi(cl_start_min)) )
		{
			printf("\n\n Invalid TIME parameter.  A valid parameter must");
			printf("\n start with a `/n', followed by two, four digit times");
			printf("\n in military time, seperated by a dash, eg., `/n0900-1400'\n\n");
			exit(1);
		}


		i=0;     /* setup for testing time */
		n=0;
		x=0;
		y=0;
		x=0;

	 /*****************************************************************
			By now, we have tested the day, and it has matched today's
			day, or was all, any other condition exited.  We tested the
			number's for first boot only, they were valid, but if the
			number was one and the file info matched the cpu info, we
			exited.  We tested the /n and the number ranges for the
			hours and minutes, and tested for /none.  They all had to
			pass in order to get here.  If /none was set we went straight
			the label doit.  Any other condition and we would
			have exited out. Now we need to parse the NOT TIMES in order
			to execute the program.  The question is, is the present
			time between the stop & start times in the /n parameter?
			x = stop time, y = present time, z = start time.
	 ******************************************************************/

	 i = atoi(cl_stop_hour) * 100;
	 n = atoi(cl_stop_min);
	 x = i+n;

	 i = atoi(cpu_hour) * 100;
	 n = atoi(cpu_min);
	 y = i+n;

	 i = atoi(cl_start_hour) * 100;
	 n = atoi(cl_start_min);
	 z = i+n;

	 if( x > z )
		{
			printf("\n\n  Your stop execution time (the first time) must be smaller then your");
			printf("\n  start time (the second time).  If you intend to set a ");
			printf("\n  execution time range that includes midnight, you must use two");
			printf("\n  copies of IFDAYIS. Copy IFDAYIS.EXE to IFDAY#2.EXE, and place both");
			printf("\n  statements in your autoexec.bat, the first one setting the start at");
			printf("\n  2359, and the second one setting the stop time at 0000.  Example:");
			printf("\n  IFDAYIS ALL 1 /N2200-2359 virscan c:");
			printf("\n  IFDAY#2 ALL 1 /N0000-0700 virscan c:");
			printf("\n\n");
			exit(1);
		}
	 if( x < y )
		if ( z > y )         /* Since we overwrote the datafile we have    */
			{                /* to restore it to its prior state, since    */
							 /* if we got here this was the first boot,    */
							 /* but during a restricted time.  Thats why   */
							 /* we have to restore the datafile. So that   */
							 /* on the next boot the datafile is the same  */
							 /* as it was, since we still haven't had a    */
							 /* boot that we could run the program on yet. */

				fp_out = fopen(datafile, "w");
				fprintf(fp_out,"%s\n",file_day);
				fprintf(fp_out,"%s\n",file_date);
				fprintf(fp_out,"%s\n",file_mon);
				fprintf(fp_out,"%s\n",file_hour);
				fprintf(fp_out,"%s\n",file_min);
				fprintf(fp_out,"%s\n",file_year);
				fclose(fp_out);

				printf("\n\n In restricted time range.  Continue normal boot.\n");
				exit(1);
			}




doit:

	system( cl_program );     /* this is where we've been trying to get to! */



} /* end of main  03:19 mon 10 jun 91 */




void test_num( char c[2] )
{

			int n;
			n=0;

			if( 0 == strcmp( c, "0\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "1\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "2\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "3\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "4\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "5\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "6\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "7\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "8\0"))
				{
					++n;
				}
			if( 0 == strcmp( c, "9\0"))
				{
					++n;
				}
			if( 0 == n )
				{
					printf("\n\n Invalid TIME parameter.  A valid parameter must");
					printf("\n start with a `/n', followed by two, four digit times");
					printf("\n kin military time, seperated by a dash, eg., `/n0900-1400'\n\n");
					exit(1);
				}
return;
}

